<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { computed, ref } from 'vue';
import { trimHtml } from '@/lib/utils';
import { usePreviewStore } from '@/stores/preview';
import Modal from '@/components/general/Modal.vue';
import Post from '@/components/preview/shared/Post.vue';

const store = usePreviewStore();
const { style, isExport } = storeToRefs(store);

const props = defineProps<{
    column: any,
    columnIndex: number
}>();

const getOneColumn = computed(() => {
    return style.value.oneColumn;
});

const getColumnWidth = computed(() => {
    if (getOneColumn.value)
        return "min(1000px, calc(100vw - 80px))!important";
    else
        return style.value.columnWidth + "px!important";
});

const isTitleModalOpen = ref(false);
const showTitleModal = (value: boolean) => {
    isTitleModalOpen.value = value;
};


const showExpandIcon = computed(() => {
    if (titleRef && titleRef.value) {
        const el = titleRef.value;
        if (el.children && el.children.length > 0) {
            const val = el.firstChild.scrollHeight > el.firstChild.clientHeight;
            return val;
        }
        return el.scrollHeight > el.clientHeight;
    }
    return false;
});

const titleRef = ref();

</script>
<template>
    <div class="relative box-border rounded-lg flex flex-col gap-4" :id="column.id"
        :style="[{ 'min-width': getColumnWidth }, { 'max-width': getColumnWidth }]"
        :class="[{ 'ml-8': props.columnIndex != null && props.columnIndex == 0 },]">
        <div class="relative box-border rounded-lg bg-white text-gray-500 shadow-md h-20 select-none"
            :class="[column.shape]" :style="{ background: column.color }">
            <h3 class="break-all align-center p-2 pt-5 flex flex-row gap-1 text-lg">
                <span ref="titleRef" class="text-ellipsis line-clamp-1 h-7 max-h-7 hyphens-auto" lang="de"
                v-html="props.column.title"></span>
                <button class="hover:bg-gray-100 px-1 rounded-md" v-if="showExpandIcon"
                    @click="showTitleModal(true)"><i class="ri-expand-diagonal-line"></i></button>
            </h3>
        </div>
        <div class="mt-5 grow overflow-auto overflow-y-auto overflow-x-hidden" :style="[{ 'min-width': getColumnWidth, 'max-width': getColumnWidth, 'min-height': isExport ? 'auto' : 'calc(100dvh - 300px)', 'max-height': isExport ? 'auto' : 'calc(100dvh - 300px)' }]">
            <div class="flex flex-col gap-4">
                <template v-for="post, elementIndex in column.posts">
                    <Post
                        :key="post.id" :id="post.id" :title="post.title" :body="post.body" :info="post.info"
                        :color="post.color" :shape="post.shape" :commentsCount="post.comments.length"
                        :postIndex="elementIndex" :columnIndex="columnIndex" v-if="post.authorized" />
                </template>
            </div>
        </div>
        <Modal v-if="isTitleModalOpen" @close="showTitleModal(false)" :labelCancel="$t('general.buttons.close')">
            <h2 class="text-xl" v-html="column.title"></h2>
        </Modal>
    </div>
</template>